#ifndef AUTOMATE_H
#define AUTOMATE_H

#include "PtrPartage.h"
struct Etat;
class Transition;
#include <vector>

class Automate
{
   std::vector<PtrPartage<Etat> > etats_;
   std::vector<PtrPartage<Transition> > transitions_;
   PtrPartage <Transition> cur_;
public:
   Automate& ajouter(PtrPartage<Etat> e)
   {
      if (e) etats_.push_back(e);
      return *this;
   }
   Automate& ajouter(PtrPartage<Transition> t)
   {
      if (t) transitions_.push_back(t);
      return *this;
   }
   void demarrer()
   {
      construire();
      lancer();
   }
   //
   // L'automate en soi
   //
   bool executer_etape();
protected:
   void lancer();
   virtual void construire() = 0;
};


#endif
